import{s as vt,n as yt,o as kt}from"../chunks/scheduler.d6170356.js";import{S as $t,i as Tt,g as s,s as l,r as u,A as xt,h as o,f as i,c as a,j as wt,u as p,x as r,k as Se,y as Ht,a as n,v as d,d as c,t as h,w as m}from"../chunks/index.fcd4cc08.js";import{H as g}from"../chunks/Heading.8660bd0e.js";function _t(We){let f,ie,ee,ne,v,le,y,ae,k,De="Tasks, or pipeline types, describe the “shape” of each model’s API (inputs and outputs) and are used to determine which Inference API and widget we want to display for any given model.",se,b,Fe='<img class="block dark:hidden" src="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/hub/tasks.png"/> <img class="hidden dark:block" src="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/hub/tasks-dark.png"/>',oe,$,Ve="This classification is relatively coarse-grained (you can always add more fine-grained task names in your model tags), so <strong>you should rarely have to create a new task</strong>. If you want to add support for a new task, this document explains the required steps.",re,T,fe,x,Be="Having a new task integrated into the Hub means that:",ue,H,Ge="<li>Users can search for all models – and datasets – of a given task.</li> <li>The Inference API supports the task.</li> <li>Users can try out models directly with the widget. 🏆</li>",pe,_,Je="Note that you don’t need to implement all the steps by yourself. Adding a new task is a community effort, and multiple people can contribute. 🧑‍🤝‍🧑",de,P,Ke='To begin the process, open a new issue in the <a href="https://github.com/huggingface/huggingface_hub/issues" rel="nofollow">huggingface_hub</a> repository. Please use the “Adding a new task” template. ⚠️Before doing any coding, it’s suggested to go over this document. ⚠️',ce,C,Qe="The first step is to upload a model for your proposed task. Once you have a model in the Hub for the new task, the next step is to enable it in the Inference API. There are three types of support that you can choose from:",he,L,Xe='<li>🤗 using a <code>transformers</code> model</li> <li>🐳 using a model from an <a href="./models-libraries">officially supported library</a></li> <li>🖨️ using a model with custom inference code. This experimental option has downsides, so we recommend using one of the other approaches.</li>',me,M,Ze="Finally, you can add a couple of UI elements, such as the task icon and the widget, that complete the integration in the Hub. 📷",ge,I,et="Some steps are orthogonal; you don’t need to do them in order. <strong>You don’t need the Inference API to add the icon.</strong> This means that, even if there isn’t full integration yet, users can still search for models of a given task.",be,A,we,j,ve,q,tt="If your model is a <code>transformers</code>-based model, there is a 1:1 mapping between the Inference API task and a <code>pipeline</code> class. Here are some example PRs from the <code>transformers</code> library:",ye,U,it='<li><a href="https://github.com/huggingface/transformers/pull/11598" rel="nofollow">Adding ImageClassificationPipeline</a></li> <li><a href="https://github.com/huggingface/transformers/pull/13342" rel="nofollow">Adding AudioClassificationPipeline</a></li>',ke,O,nt="Once the pipeline is submitted and deployed, you should be able to use the Inference API for your model.",$e,R,Te,z,lt='The Hub also supports over 10 open-source libraries in the <a href="https://github.com/huggingface/api-inference-community" rel="nofollow">Community Inference API</a>.',xe,E,at="<strong>Adding a new task is relatively straightforward and requires 2 PRs:</strong>",He,N,st='<li>PR 1: Add the new task to the API <a href="https://github.com/huggingface/api-inference-community/blob/main/api_inference_community/validation.py" rel="nofollow">validation</a>. This code ensures that the inference input is valid for a given task. Some PR examples:<ul><li><a href="https://github.com/huggingface/huggingface_hub/commit/5f040a117cf2a44d704621012eb41c01b103cfca#diff-db8bbac95c077540d79900384cfd524d451e629275cbb5de7a31fc1cd5d6c189" rel="nofollow">Add text-to-image</a></li> <li><a href="https://github.com/huggingface/huggingface_hub/commit/141e30588a2031d4d5798eaa2c1250d1d1b75905#diff-db8bbac95c077540d79900384cfd524d451e629275cbb5de7a31fc1cd5d6c189" rel="nofollow">Add audio-classification</a></li> <li><a href="https://github.com/huggingface/huggingface_hub/commit/dbea604a45df163d3f0b4b1d897e4b0fb951c650#diff-db8bbac95c077540d79900384cfd524d451e629275cbb5de7a31fc1cd5d6c189" rel="nofollow">Add tabular-classification</a></li></ul></li> <li>PR 2: Add the new task to a library docker image. You should also add a template to <a href="https://github.com/huggingface/api-inference-community/tree/main/docker_images/common/app/pipelines" rel="nofollow"><code>docker_images/common/app/pipelines</code></a> to facilitate integrating the task in other libraries. Here is an example PR:<ul><li><a href="https://github.com/huggingface/huggingface_hub/commit/6926fd9bec23cb963ce3f58ec53496083997f0fa#diff-3f1083a92ca0047b50f9ad2d04f0fe8dfaeee0e26ab71eb8835e365359a1d0dc" rel="nofollow">Add text-classification to spaCy</a></li></ul></li>',_e,Y,Pe,S,ot="<strong>My model is not supported by any library. Am I doomed? 😱</strong>",Ce,W,rt='No, you’re not! The <a href="https://github.com/huggingface/api-inference-community/tree/main/docker_images/generic" rel="nofollow">generic Inference API</a> is an experimental Docker image for quickly prototyping new tasks and introducing new libraries,  which should allow you to have a new task in production with very little development from your side.',Le,D,ft='How does it work from the user’s point of view? Users create a copy of a <a href="https://huggingface.co/templates" rel="nofollow">template</a> repo for their given task. Users then need to define their <code>requirements.txt</code> and fill <code>pipeline.py</code>. Note that this is intended for quick experimentation and prototyping instead of fast production use-cases.',Me,F,Ie,V,ut="The Hub allows users to filter models by a given task. To do this, you need to add the task to several places. You’ll also get to pick an icon for the task!",Ae,B,pt="<li>Add the task type to <code>Types.ts</code></li>",je,G,dt='In <a href="https://github.com/huggingface/huggingface.js/blob/main/packages/tasks/src/pipelines.ts" rel="nofollow">huggingface.js/packages/tasks/src/pipelines.ts</a>, you need to do a couple of things',qe,J,ct='<li>Add the type to <code>PIPELINE_DATA</code>. Note that pipeline types are sorted into different categories (NLP, Audio, Computer Vision, and others).</li> <li>You will also need to fill minor changes in <a href="https://github.com/huggingface/huggingface.js/blob/main/packages/tasks/src/tasks/index.ts" rel="nofollow">huggingface.js/packages/tasks/src/tasks/index.ts</a></li>',Ue,w,ht="<li>Choose an icon</li>",Oe,K,mt='You can add an icon in the <a href="https://github.com/huggingface/huggingface.js/tree/main/packages/widgets/src/lib/components/Icons" rel="nofollow">lib/Icons</a> directory. We usually choose carbon icons from <a href="https://icones.js.org/collection/carbon" rel="nofollow">https://icones.js.org/collection/carbon</a>. Also add the icon to <a href="https://github.com/huggingface/huggingface.js/blob/main/packages/widgets/src/lib/components/PipelineIcon/PipelineIcon.svelte" rel="nofollow">PipelineIcon</a>.',Re,Q,ze,X,gt='Once the task is in production, what could be more exciting than implementing some way for users to play directly with the models in their browser? 🤩 You can find all the widgets <a href="https://huggingface.co/spaces/huggingfacejs/inference-widgets" rel="nofollow">here</a>.',Ee,Z,bt='If you would be interested in contributing with a widget, you can look at the <a href="https://github.com/huggingface/huggingface.js/tree/main/packages/widgets" rel="nofollow">implementation</a> of all the widgets.',Ne,te,Ye;return v=new g({props:{title:"Tasks",local:"tasks",headingTag:"h1"}}),y=new g({props:{title:"What’s a task?",local:"whats-a-task",headingTag:"h2"}}),T=new g({props:{title:"Overview",local:"overview",headingTag:"h2"}}),A=new g({props:{title:"Adding new tasks to the Hub",local:"adding-new-tasks-to-the-hub",headingTag:"h2"}}),j=new g({props:{title:"Using Hugging Face transformers library",local:"using-hugging-face-transformers-library",headingTag:"h3"}}),R=new g({props:{title:"Using Community Inference API with a supported library",local:"using-community-inference-api-with-a-supported-library",headingTag:"h3"}}),Y=new g({props:{title:"Adding Community Inference API for a quick prototype",local:"adding-community-inference-api-for-a-quick-prototype",headingTag:"h3"}}),F=new g({props:{title:"UI elements",local:"ui-elements",headingTag:"h3"}}),Q=new g({props:{title:"Widget",local:"widget",headingTag:"h3"}}),{c(){f=s("meta"),ie=l(),ee=s("p"),ne=l(),u(v.$$.fragment),le=l(),u(y.$$.fragment),ae=l(),k=s("p"),k.textContent=De,se=l(),b=s("div"),b.innerHTML=Fe,oe=l(),$=s("p"),$.innerHTML=Ve,re=l(),u(T.$$.fragment),fe=l(),x=s("p"),x.textContent=Be,ue=l(),H=s("ul"),H.innerHTML=Ge,pe=l(),_=s("p"),_.textContent=Je,de=l(),P=s("p"),P.innerHTML=Ke,ce=l(),C=s("p"),C.textContent=Qe,he=l(),L=s("ul"),L.innerHTML=Xe,me=l(),M=s("p"),M.textContent=Ze,ge=l(),I=s("p"),I.innerHTML=et,be=l(),u(A.$$.fragment),we=l(),u(j.$$.fragment),ve=l(),q=s("p"),q.innerHTML=tt,ye=l(),U=s("ul"),U.innerHTML=it,ke=l(),O=s("p"),O.textContent=nt,$e=l(),u(R.$$.fragment),Te=l(),z=s("p"),z.innerHTML=lt,xe=l(),E=s("p"),E.innerHTML=at,He=l(),N=s("ul"),N.innerHTML=st,_e=l(),u(Y.$$.fragment),Pe=l(),S=s("p"),S.innerHTML=ot,Ce=l(),W=s("p"),W.innerHTML=rt,Le=l(),D=s("p"),D.innerHTML=ft,Me=l(),u(F.$$.fragment),Ie=l(),V=s("p"),V.textContent=ut,Ae=l(),B=s("ol"),B.innerHTML=pt,je=l(),G=s("p"),G.innerHTML=dt,qe=l(),J=s("ul"),J.innerHTML=ct,Ue=l(),w=s("ol"),w.innerHTML=ht,Oe=l(),K=s("p"),K.innerHTML=mt,Re=l(),u(Q.$$.fragment),ze=l(),X=s("p"),X.innerHTML=gt,Ee=l(),Z=s("p"),Z.innerHTML=bt,Ne=l(),te=s("p"),this.h()},l(e){const t=xt("svelte-u9bgzb",document.head);f=o(t,"META",{name:!0,content:!0}),t.forEach(i),ie=a(e),ee=o(e,"P",{}),wt(ee).forEach(i),ne=a(e),p(v.$$.fragment,e),le=a(e),p(y.$$.fragment,e),ae=a(e),k=o(e,"P",{"data-svelte-h":!0}),r(k)!=="svelte-1eg00uh"&&(k.textContent=De),se=a(e),b=o(e,"DIV",{class:!0,"data-svelte-h":!0}),r(b)!=="svelte-1lsch2v"&&(b.innerHTML=Fe),oe=a(e),$=o(e,"P",{"data-svelte-h":!0}),r($)!=="svelte-1w57hvb"&&($.innerHTML=Ve),re=a(e),p(T.$$.fragment,e),fe=a(e),x=o(e,"P",{"data-svelte-h":!0}),r(x)!=="svelte-15av66z"&&(x.textContent=Be),ue=a(e),H=o(e,"UL",{"data-svelte-h":!0}),r(H)!=="svelte-8gq8pt"&&(H.innerHTML=Ge),pe=a(e),_=o(e,"P",{"data-svelte-h":!0}),r(_)!=="svelte-tuuwdi"&&(_.textContent=Je),de=a(e),P=o(e,"P",{"data-svelte-h":!0}),r(P)!=="svelte-1xa8q81"&&(P.innerHTML=Ke),ce=a(e),C=o(e,"P",{"data-svelte-h":!0}),r(C)!=="svelte-1ncnre8"&&(C.textContent=Qe),he=a(e),L=o(e,"UL",{"data-svelte-h":!0}),r(L)!=="svelte-iyd5dv"&&(L.innerHTML=Xe),me=a(e),M=o(e,"P",{"data-svelte-h":!0}),r(M)!=="svelte-18hwl3y"&&(M.textContent=Ze),ge=a(e),I=o(e,"P",{"data-svelte-h":!0}),r(I)!=="svelte-1qljhbq"&&(I.innerHTML=et),be=a(e),p(A.$$.fragment,e),we=a(e),p(j.$$.fragment,e),ve=a(e),q=o(e,"P",{"data-svelte-h":!0}),r(q)!=="svelte-tokqq5"&&(q.innerHTML=tt),ye=a(e),U=o(e,"UL",{"data-svelte-h":!0}),r(U)!=="svelte-m5tbso"&&(U.innerHTML=it),ke=a(e),O=o(e,"P",{"data-svelte-h":!0}),r(O)!=="svelte-1rm7guk"&&(O.textContent=nt),$e=a(e),p(R.$$.fragment,e),Te=a(e),z=o(e,"P",{"data-svelte-h":!0}),r(z)!=="svelte-u8woez"&&(z.innerHTML=lt),xe=a(e),E=o(e,"P",{"data-svelte-h":!0}),r(E)!=="svelte-pvk38g"&&(E.innerHTML=at),He=a(e),N=o(e,"UL",{"data-svelte-h":!0}),r(N)!=="svelte-9oxdcc"&&(N.innerHTML=st),_e=a(e),p(Y.$$.fragment,e),Pe=a(e),S=o(e,"P",{"data-svelte-h":!0}),r(S)!=="svelte-1rw0of7"&&(S.innerHTML=ot),Ce=a(e),W=o(e,"P",{"data-svelte-h":!0}),r(W)!=="svelte-1x9qmgu"&&(W.innerHTML=rt),Le=a(e),D=o(e,"P",{"data-svelte-h":!0}),r(D)!=="svelte-1n3w358"&&(D.innerHTML=ft),Me=a(e),p(F.$$.fragment,e),Ie=a(e),V=o(e,"P",{"data-svelte-h":!0}),r(V)!=="svelte-p8vjj8"&&(V.textContent=ut),Ae=a(e),B=o(e,"OL",{"data-svelte-h":!0}),r(B)!=="svelte-1jsxx4s"&&(B.innerHTML=pt),je=a(e),G=o(e,"P",{"data-svelte-h":!0}),r(G)!=="svelte-1uzhqbb"&&(G.innerHTML=dt),qe=a(e),J=o(e,"UL",{"data-svelte-h":!0}),r(J)!=="svelte-swx4ji"&&(J.innerHTML=ct),Ue=a(e),w=o(e,"OL",{start:!0,"data-svelte-h":!0}),r(w)!=="svelte-ppajzd"&&(w.innerHTML=ht),Oe=a(e),K=o(e,"P",{"data-svelte-h":!0}),r(K)!=="svelte-170oba6"&&(K.innerHTML=mt),Re=a(e),p(Q.$$.fragment,e),ze=a(e),X=o(e,"P",{"data-svelte-h":!0}),r(X)!=="svelte-1xlspt7"&&(X.innerHTML=gt),Ee=a(e),Z=o(e,"P",{"data-svelte-h":!0}),r(Z)!=="svelte-z2f4h"&&(Z.innerHTML=bt),Ne=a(e),te=o(e,"P",{}),wt(te).forEach(i),this.h()},h(){Se(f,"name","hf:doc:metadata"),Se(f,"content",Pt),Se(b,"class","flex justify-center"),Se(w,"start","2")},m(e,t){Ht(document.head,f),n(e,ie,t),n(e,ee,t),n(e,ne,t),d(v,e,t),n(e,le,t),d(y,e,t),n(e,ae,t),n(e,k,t),n(e,se,t),n(e,b,t),n(e,oe,t),n(e,$,t),n(e,re,t),d(T,e,t),n(e,fe,t),n(e,x,t),n(e,ue,t),n(e,H,t),n(e,pe,t),n(e,_,t),n(e,de,t),n(e,P,t),n(e,ce,t),n(e,C,t),n(e,he,t),n(e,L,t),n(e,me,t),n(e,M,t),n(e,ge,t),n(e,I,t),n(e,be,t),d(A,e,t),n(e,we,t),d(j,e,t),n(e,ve,t),n(e,q,t),n(e,ye,t),n(e,U,t),n(e,ke,t),n(e,O,t),n(e,$e,t),d(R,e,t),n(e,Te,t),n(e,z,t),n(e,xe,t),n(e,E,t),n(e,He,t),n(e,N,t),n(e,_e,t),d(Y,e,t),n(e,Pe,t),n(e,S,t),n(e,Ce,t),n(e,W,t),n(e,Le,t),n(e,D,t),n(e,Me,t),d(F,e,t),n(e,Ie,t),n(e,V,t),n(e,Ae,t),n(e,B,t),n(e,je,t),n(e,G,t),n(e,qe,t),n(e,J,t),n(e,Ue,t),n(e,w,t),n(e,Oe,t),n(e,K,t),n(e,Re,t),d(Q,e,t),n(e,ze,t),n(e,X,t),n(e,Ee,t),n(e,Z,t),n(e,Ne,t),n(e,te,t),Ye=!0},p:yt,i(e){Ye||(c(v.$$.fragment,e),c(y.$$.fragment,e),c(T.$$.fragment,e),c(A.$$.fragment,e),c(j.$$.fragment,e),c(R.$$.fragment,e),c(Y.$$.fragment,e),c(F.$$.fragment,e),c(Q.$$.fragment,e),Ye=!0)},o(e){h(v.$$.fragment,e),h(y.$$.fragment,e),h(T.$$.fragment,e),h(A.$$.fragment,e),h(j.$$.fragment,e),h(R.$$.fragment,e),h(Y.$$.fragment,e),h(F.$$.fragment,e),h(Q.$$.fragment,e),Ye=!1},d(e){e&&(i(ie),i(ee),i(ne),i(le),i(ae),i(k),i(se),i(b),i(oe),i($),i(re),i(fe),i(x),i(ue),i(H),i(pe),i(_),i(de),i(P),i(ce),i(C),i(he),i(L),i(me),i(M),i(ge),i(I),i(be),i(we),i(ve),i(q),i(ye),i(U),i(ke),i(O),i($e),i(Te),i(z),i(xe),i(E),i(He),i(N),i(_e),i(Pe),i(S),i(Ce),i(W),i(Le),i(D),i(Me),i(Ie),i(V),i(Ae),i(B),i(je),i(G),i(qe),i(J),i(Ue),i(w),i(Oe),i(K),i(Re),i(ze),i(X),i(Ee),i(Z),i(Ne),i(te)),i(f),m(v,e),m(y,e),m(T,e),m(A,e),m(j,e),m(R,e),m(Y,e),m(F,e),m(Q,e)}}}const Pt='{"title":"Tasks","local":"tasks","sections":[{"title":"What’s a task?","local":"whats-a-task","sections":[],"depth":2},{"title":"Overview","local":"overview","sections":[],"depth":2},{"title":"Adding new tasks to the Hub","local":"adding-new-tasks-to-the-hub","sections":[{"title":"Using Hugging Face transformers library","local":"using-hugging-face-transformers-library","sections":[],"depth":3},{"title":"Using Community Inference API with a supported library","local":"using-community-inference-api-with-a-supported-library","sections":[],"depth":3},{"title":"Adding Community Inference API for a quick prototype","local":"adding-community-inference-api-for-a-quick-prototype","sections":[],"depth":3},{"title":"UI elements","local":"ui-elements","sections":[],"depth":3},{"title":"Widget","local":"widget","sections":[],"depth":3}],"depth":2}],"depth":1}';function Ct(We){return kt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class At extends $t{constructor(f){super(),Tt(this,f,Ct,_t,vt,{})}}export{At as component};
